c DALL usage example program
c Copyright_OML 1999 Makio Ishiguro
c Note: DALL routine contained in this file is the one extracted from
c ARdock package. Those users who are interested in using DALL on a
c parallel computer, down-load the source code of ARdock package.
c
c ARdock, an Auto-Regressive model analyzer
c Copiright_OML 1999Makio Ishiguro, Hiroko Kato & Hirotugu Akaike 
c (http://www.ism.ac.jp/software/ismlib/soft.e.html)
c
c This version is obtained by applying
c  dall.0-1.patch to the original example3.f
corrected2000.10.20 corrections are made by M.I.
c  This correction is necessary to avoid possible dead-locks.  
c 1 "gauss.F" 
      program gauss                                     
c 5 "gauss.F" 

      parameter  (ipmax=4)
      implicit  real*8( a-h,o-z )                        
      dimension ax(ipmax),ay(ipmax),axy(ipmax)
      dimension g(ipmax), vd(ipmax,ipmax+5),step(ipmax)       
      external llx,lly,llxy   
c    
      myid = 0
c 16 "gauss.F" 


      do 1 i=1,ipmax
 1    step(i) = 0.001d0

      ipx=2
      ax(1) = 0.d0
      ax(2) = 1.d0
      call dall(llx,ax,ipx,el,g,vd,endc,step,0,3)   
      if(myid .eq. 0) then
         write(6,*) ' meanx(mle)=',ax(1)            
         write(6,*) ' variancex(mle)=',ax(2)            
         write(6,*) ' maximum likelihood=',el
         write(6,*) ' number of parameter=',ipx
         aic= -2*el + 2*ipx            
         write(6,'('' AICx='',F10.2)') aic            
      end if

      ipy=2
      ay(1) = 0.d0
      ay(2) = 1.d0
      call dall(lly,ay,ipy,el,g,vd,endc,step,0,3)   
      if(myid .eq. 0) then
         write(6,*) ' meany(mle)=',ay(1)            
         write(6,*) ' variancey(mle)=',ay(2)            
         write(6,*) ' maximum likelihood=',el
         write(6,*) ' number of parameter=',ipy
         aic= -2*el + 2*ipy            
         write(6,'('' AICy='',F10.2)') aic            
      end if

      ipxy=3
      axy(1) = (ax(1) + ay(1))*0.5d0
      axy(2) = ax(2)
      axy(3) = ay(2)
      call dall(llxy,axy,ipxy,el,g,vd,endc,step,0,3)   
      if(myid .eq. 0) then
         write(6,*) ' meanxy(mle)=',axy(1)            
         write(6,*) ' variancedx1(mle)=',axy(2)            
         write(6,*) ' variancey(mle)=',axy(3)            
         write(6,*) ' maximum likelihood=',el
         write(6,*) ' number of parameter=',ipxy
         aic= -2*el + 2*ipxy            
         write(6,'('' AICxy='',F10.2)') aic            
      end if
c 63 "gauss.F" 

      stop 
      end                                              
   
      subroutine llx(p,m,el,lel)                         
      implicit real*8 (a-h,o-z)                          
      dimension p(m)                                     
      common /i721/ n
      common /r721/ x(11)
      data pi /3.14159265d0/
      lel=0
      if(p(2) .gt. 0.d0) then
         sum=0.d0
         do 1 i=1,n
            sum=sum+(x(i)-p(1))**2
    1    continue
         el= -n*0.5*( dlog(pi*2)+dlog(p(2)) ) - 0.5*sum/p(2)
         lel=1 
      end if
      return                                             
      end                                                
c
      subroutine lly(p,m,el,lel)                         
      implicit real*8 (a-h,o-z)                          
      dimension p(m)                                     
      common /i722/ n
      common /r722/ x(8)
      data pi /3.14159265d0/
      lel=0
      if(p(2) .gt. 0.d0) then
         sum=0.d0
         do 1 i=1,n
            sum=sum+(x(i)-p(1))**2
    1    continue
         el= -n*0.5*( dlog(pi*2)+dlog(p(2)) ) - 0.5*sum/p(2)
         lel=1 
      end if
      return                                             
      end

c
      subroutine llxy(p,m,el,lel)                         
      implicit real*8 (a-h,o-z)                          
      dimension p(m),px(2),py(2)
      px(1)=p(1)
      px(2)=p(2)
      call llx(px,2,elx,lel)
      if(lel .eq. 0) return
      py(1)=p(1)
      py(2)=p(3)
      call lly(py,2,ely,lel)
      if(lel .eq. 0) return
      el=elx+ely
      return                                             
      end                                                
c
      block data ex72
      implicit real*8 (a-h,o-z)                          
      common /i721/ n1
      common /r721/ x1(11)
      common /i722/ n2
      common /r722/ x2(8)
      data n1/11/
      data x1/ 0.73, -0.06,  1.04,  2.29,  0.51,
     *        -0.45,  1.03,  0.44,  0.02,  0.11,
     *        -2.42 /
      data n2/8/
      data x2/ 0.10,  0.56, -1.11, -0.48,  3.46,
     *        -2.39,  0.36,  4.56 /
      end

c------------ dall routine -------------------
checkpoint:       lano =    75/129/sp2.@990422.@152623 ........
contents  11. dall                 subpackage
contents    11.1  dall                
c reusable
      subroutine dall (
     * Model , A , Ip , El , G , Vd , Endc , Step , Limit , Lpsw )
       implicit real*8 ( a-h , o-z )                                      
c 144 "gauss.F" 

c 1 "./dall.env" 1
       parameter (mpiprocs = 1)
       dimension mPIL ( MPIPROCS ) , mPIB ( MPIPROCS )
       common  /commpi/ iNFO , mYID , nPROCS , mPI , mPIL , mPIB 

c 146 "gauss.F" 2
       parameter ( nprof = 11)                                            
       common  /cdall/ NCOUNT , limitx , lpswmpi 
       dimension El (1) , A ( Ip )                                        
       dimension G ( Ip ) ,  Vd ( Ip , Ip  + 5)             
       dimension y ( nprof ) , Step ( Ip )                                   
       external Model 
       character*1  io 
c 155 "gauss.F" 

c 160 "gauss.F" 

       data inisub /0/
c      .............................................................
c      history 
c      version       date         location 
c      F_MPI_1       1996.11      ISMLIB   
c         several minor changes. The most crucial one is handling 
c         of Model output lel. Now ,  it should be:
c           lel > 0 if Model is successfully evaluated , 
c               = 0 if Model can not be evalluated.          
c      version - 0     1998.12 
c   history             - 1989.7   original version 
c                       - 1996.11  MPI version 
c                       - 1997.7   minor clean - up ( lpswmpi etc.)
c                       - 1997.8   WHYMPER option 
c                       - 1998.5   mask option 
c                       - 1998.6   MPION / OFF control 
c                       - 1998.10  lel sence reversed 
c 
c      DALL: Davidon's Algorithm for Log Likelihood Maximization             '
c      --- A FORTRAN subroutine for statistical model builders -- 
c      Version F_MPI_2 ( for MPI - parallel computer ) 
c      Copyright_OML 1999 M. Ishiguro & H. Akaike 
c       The source code of this subroutine, as a part of the ARdock package,
c       can be obtained from ISMLIB(ftp://ftp.ism.ac.jp/pub/ISMLIB/)
c       of the Institute of Statistical Mathematics without any charge. 
c       On the conditions that terms of the OPEN MARKET LICENCE for software
c       (ftp://ftp.ism.ac.jp/pub/ISMLIB/OML/OML-SW-E-1996) are observed and 
c       that the copyright holder nor the Institute of Statistical Mathematics 
c       take no responsibility on any result from the use, this subroutine 
c       can be used or modified freely. On the condition that this note is 
c       attached as it is, this subroutine can be redistributed.
c      Model        - input. subroutine name.                          
c      A ( ip )       - input. parameter.                                
c      Ip          - input. number of free parameter.                 
c      El          - output. maximum log likelihood.                  
c      G ( ip )       - output. final gradient     
c      Vd ( ip , ip  + 5) - output / work area. 
c                      first ip columns: inverse Hessian matrix estimation 
c      Endc        - output. end code.                                
c                    endc =  numerical differentiation routine call count 
c                          + lcode / 100 
c 
c                   lcode     message 
c                       0  D1:Successfully finished 
c                             Bill ended with abs (RHO) < rhomin. 
c                      50  D1:NCOUNT exeeded given limit.
c                             Bill stopped midway.
c                      70  D1:Bill reached dead end with 
c                                     abs ( log LAMBDA) < ramlim.
c                      71  D1:Bill reached dead end with 
c                                      ISPHI   =  isplim.    
c                      72  D1:Bill reached dead end with 
c                                     initial search failure.
c                      85  D1:Bad initial guess!
c                             function can't be evaluated.                    '
c                      90  D0:Setting of lel variable is incorrect. 
c                             Set lel = 1 when function can be evaluated , 
c                             set lel = 0 if not.
c                      95  D0:step vector has zero element. 
c                         (The number after D represents the output level.)
c 
c      Step ( ip )    - input. step size for the numerical 
c                           differentiation. 
c      Limit       - input. numerical differentiation routine call limit 
c                           Set limit  =  0 for no - limit option.
c      Lpsw        - input. output level control.  0 = < lpsw < = 3. 
       io = 'I'
 9100  continue 
c 247 "gauss.F" 

       if( io .ne. 'O') then
          goto 9200
       end if 
c      ------ 
       El (1) = val 
       return 
c      ====== 
 9200  continue 
       io = 'O'
c      1997.8 M.I. 
c 266 "gauss.F" 

       lpswmpi  =  Lpsw 
       nprocs  =  1 
       limitx  =  Limit 
c 274 "gauss.F" 

c                                                                     
c      function check 
       lel =  - 1496 
c 286 "gauss.F" 

       call Model ( A , Ip , El , lel )

       val = El (1)                         
       if( lel .le. 0) then                                              
         if( lel .eq.  - 1496) then                                     
c            ********                                                
            lcode = 90 
            if( myid .eq. 0) then 
               write(6,*) 'D0:Setting of lel variable is not correct.'    
               write(6,*) '   Set lel=1 when function can be evaluated.' 
            end if 
            goto 1496                                             
c           ------------------------------- >1496                   
         end if 
         if( lel .lt. 0) then                                           
c            ********                                                   
            lcode = 90 
            if( myid .eq. 0) then     
               write(6,*) 'D0:Setting of lel variable is not correct.'    
               write(6,*) 
     *               '   Set lel = 0 when function can''t be evaluated.' 
            end if 
            goto 1496                                                
c           ------------------------------- >1496                   
         end if                                                       
c         ********                                                      
         lcode  =  85 
         if( lpswmpi .gt. 0) then     
            write(6,*) 'D1:lel = 0  Bad initial guess!'                     
            write(6,*) '   function can''t be evaluated.' 
         end if  
         goto 1496                                                   
c        ------------------------------- >1496                         
       end if                                                          
c      :                                                              
c      :                                                              
c      initialization 
       do 1234 i = 1 , Ip                                                  
         if( Step ( i ) .eq. 0) then 
c            ********                                                      
            lcode  =  95 
            if( myid .eq. 0) then        
               write(6,*) 'D0:step vector has zero element.'    
            end if 
            goto 1496                                                   
c           ------------------------------- >1496                         
         end if 
       Vd ( i , Ip  + 1) = A ( i )
 1234  continue 
       NCOUNT = 0                    
       ireset = 0                                                        
       drop = 0.d0                                                       
c      :                                                              
       if( lpswmpi .gt.0) then 
         write(6 , 6149)                                    
         write(6,*) 'D1:number of processor  = ' , nprocs 
         if( Limit .eq. 0) then 
            write(6,*) 'D1:no Limit for NCOUNT'
         else 
            write(6,*) 'D1:NCOUNT Limit = ' , Limit 
         end if 
 6149    format( /  , 
     *   ' D1:==========  log likelihood maximization =========')
       end if 
c      :                                                              
c      :                                                              
c      + =============================== <4210                          
 4210  continue                                                        
c      innovation variance ,  gradient and hessian computation 
       call numdif ( Model , A , Ip , El , ihess , G , Vd , 2 , Step )
       val = El (1)
 4211  continue                                                        
c      :                                                              
       vinit = val                                                       
c      :                                                              
c      : ...............................                              
         if( lpswmpi .gt.1) then                                          
c           initial print out                                         
            write(6 , 3112) ireset                                      
 3112       format( /  , ' D2:Hessian reset count  = ' , i3)                  
            write(6 , 1008)  2 ,  vinit                                   
 1008       format(1x  , 'D' , i1 , ':value = ' , f15.2)                        
            write(6 , 1621) 2                                           
 1621       format(1x  , 'D' , i1 , ':point')                               
            write(6 , 6666) ( A ( i ) , i = 1 , Ip )                               
         end if                                                       
c      : ...............................                              
c      :                                                              
c      Inverse of Hessian computation.                                 
       do 1910 i = 1 , Ip              
         if( Vd ( i , i ) .lt. 0.d0) then                                   
            Vd ( i , i ) = 1.d0 / Vd ( i , i )                                 
         else                                                         
            if( G ( i ) .eq. 0.d0) then                                   
               Vd ( i , i ) =  - 1.d0                                          
            else                                                      
                Vd ( i , i ) =  - Step ( i ) / 
     *          dabs ( G ( i )) * 1.d2                     
            end if                                                    
         end if            
 1910  continue                                                        
c      :                                                              
c      :                                                              
c      Davidon's procedure                                                    '
       call bill ( Model , A , Ip , El , G , Vd , lcode , Step , 
     * Vd (1 , Ip  + 2) , Vd (1 , Ip  + 3) , Vd (1 , Ip  + 4) ,
     * Vd (1 , Ip  + 5))
       val = El (1) 
c      :                                                              
c      :                                                              
       vdif = val - vinit                                                  
       drop = drop + vdif                                                  
c      : ...............................    
         if( lpswmpi .gt. 1) then 
            write(6 , 1009) 2 , vdif                         
            write(6,'('' D2:NCOUNT = '',I6)') NCOUNT 
 1009       format(1x ,'D',i1,':val. dif. = ',f15.2)
         end if                       
c      : ...............................      
c      :                                                              
c      :                                                              
       if( lcode .eq. 0 .or. vdif .eq. 0.d0) then 
         if( lpswmpi .gt. 0) then 
            if( lcode .eq. 0) 
     *      write(6,*) 'D1:Bill ended with abs (RHO) < rhomin.'       
            if( lcode .eq. 70) 
     *      write(6,*) 'D1:Bill ended with abs ( log LAMBDA) < ramlim.'       
            if( lcode .eq. 71) 
     *      write(6,*) 'D1:Bill ended with  ISPHI  =  isplim.'       
            if( lcode .eq. 72) 
     *      write(6,*) 'D1:Bill ended with initial search failure.'       
         end if 
         goto 1498                                                   
c         ================================ > 1498                       
       end if 
c      :
c      :
       if( lcode .eq. 50) then 
         if( lpswmpi .gt. 0) 
     *   write(6,*) 'D1:NCOUNT exeeded given limit.'     
         goto 1498                                                   
c         ================================ > 1498                       
       end if 
c      :
c      :
       ireset = ireset + 1                                                 
       goto 4210                                                      
c      ================================== >4210                         
c      :                                                              
c      :                                                              
c      :                                                              
c      :                                                              
c      +  ==================================== <1498                    
 1498  continue 
c      :
c      :                                                         
       if( lpswmpi .gt. 0) then                                            
         if( lpswmpi .gt. 1 ) write(6,6150)                                
 6150    format(1x ,'D2: ==========   Summary  ========= ') 
         write(6,1008) 1 , val                                          
         write(6,1621) 1                                              
         write(6,6666) ( A ( i ) , i = 1 , Ip )                                
 6666    format(1x  , 5x , 5d13.5 / (1x  , 5x , 5d13.5)) 
         if( ihess .eq. 0 .and. lpswmpi .gt. 1) then                      
            write(6 , 1010)                                             
 1010       format(1x  , 'D2:final gradient')                           
            write(6 , 6666) ( G ( i ) , i = 1 , Ip )                               
         end if                                                       
         write(6 , 1009) 1 , drop                                         
       end if                                                          
c      :                                                              
c      --------------------------------- <1496                        
 1496  Endc = NCOUNT + lcode / 100.d0                                        
c      :                                                              
       stepx = 0.d0                                                  
       do 8762 i = 1 , Ip                                                
         stepx = stepx + ( A ( i ) - Vd ( i , Ip  + 1)) ** 2 
 8762  continue 
c      :                                                           
       if( stepx .ne. 0.d0) then 
         if( Lpsw .gt. 1) then                                    
            rlim = 0.d0                                                 
            call eval ( Model , El , Vd (1 , Ip  + 1) , A , Ip ,  
     i      nprof , 
     o      y , rlim , 
     w      Vd (1 , Ip  + 2) , Vd (1 , Ip  + 3) , Vd (1 , Ip  + 4))
            if( lpswmpi .ne. 0) then                                           
               write(6 , 654)                                              
  654          format(1x  , 'D2:global profile')                           
               call lgraph (
     i         y , nprof , rlim , 'log likelihood' , 1.d0 , 
     i         0.d0 , 0.d0 , 0.d0 , 1.d0 / ( nprof - 1) ,
     i         ' ' , nprof , 1)
            end if 
         end if 
       else                                                         
         if( lpswmpi .gt. 0) then                                            
            write(6 , 866)                                              
  866       format(1x  , 'D1:didn''t move')                             
         end if 
       end if                                                       
c      :
       if( lpswmpi .gt. 0) then 
         write(6 , 8654) ireset                                         
 8654    format(1x  , 'D1:Hessian reset count  = ' , i4)                    
         write(6 , 8655) Endc                                           
 8655    format(1x  , 'D1:end code  = ' , f7.2)                             
         write(6 , 867)                                                 
  867    format(1x ,'D1:============= end of maximization ===========')
       end if                                                          
c      :                                                              
       goto 9100 
      end                                                             

checkpoint:      lano =    76/129/sp2.@990422.@152623 ........
contents    11.2  bill                
c reusable
      subroutine bill (
     * Model , X , Ip , El , G , Vd , Lcode , Step , c , sx , sg , sr ) 
       implicit real*8 ( a-h , o-z )                                 
c 1 "./dall.env" 1
       parameter (mpiprocs = 1)
       dimension mPIL ( MPIPROCS ) , mPIB ( MPIPROCS )
       common  /commpi/ iNFO , mYID , nPROCS , mPI , mPIL , mPIB 

c 508 "gauss.F" 2
       common  /cdall/ NCOUNT , limitx , lpswmpi 
       parameter ( ramlim  =  0.2d0)                
       dimension El (1) , Vd ( Ip , Ip )                    
       dimension X ( Ip ) , G ( Ip ) , c ( Ip ) , sx ( Ip ) , 
     * sg ( Ip ) , sr ( Ip ) ,
     * Step ( Ip )               
       external Model                                                   
       character*1  io 
c 518 "gauss.F" 

       data cst1  / 1.0d - 00 /  ,  cst05  / 0.5d - 00 /  ,            
     * consta  / 0.25d - 00 /  ,  constb  / 4.0d - 00 /  , 
     * rhomin  / 0.0001d0 /  ,  isplim  / 5 /                    
       data inisub /0/
c      ........................................................
c      history 
c      version       date         location 
c      F_MPI_1       1996.11      ISMLIB   
c         several minor changes. The most crucial one is handling 
c         of Model output lel. Now ,  it should be:
c           lel > 0 if Model is successfully evaluated , 
c               = 0 if Model can not be evalluated.
c      version - 0     1998.12          
c      bill 
c      Copyright_OML 1999 M. Ishiguro & H. Akaike 
c       The source code of this subroutine, as a part of the ARdock package,
c       can be obtained from ISMLIB(ftp://ftp.ism.ac.jp/pub/ISMLIB/)
c       of the Institute of Statistical Mathematics without any charge. 
c       On the conditions that terms of the OPEN MARKET LICENCE for software
c       (ftp://ftp.ism.ac.jp/pub/ISMLIB/OML/OML-SW-E-1996) are observed and 
c       that the copyright holder nor the Institute of Statistical Mathematics 
c       take no responsibility on any result from the use, this subroutine 
c       can be used or modified freely. On the condition that this note is 
c       attached as it is, this subroutine can be redistributed.
       io = 'I'
 9100  continue 
       if( io .eq. 'O') then
          El (1) = val 
       end if
c 569 "gauss.F" 

       if( io .ne. 'O') then
          val = El (1)
          goto 9200
       end if 
c      ------
       return 
c      ====== 
 9200  continue 
       io = 'O'
c      :                                                              
c      constant     
       isplim = Ip   
c      :                                                              
c      initialization 
       ISPHI = 0   
corrected2000.10.20  1 line correction made by M.I.
c       isphix = 1 
       isphix = 0 
       itn = 0                                                           
       PHI = val                                                         
       if( lpswmpi .eq. 3) write(6,666)                                
  666  format(1x ,'B3: NCOUNT',10x,' PHI',5x,'  SPHI-PHI',
     * 7x,'RHO', 2x,'LAMBDA-1',2x,' ISPHI')           
c      :                                                              
c      correction term c ( X ) = v * G ( X ) computation                         
       do 100 i = 1 , Ip                                                   
       c ( i ) = Vd ( i , i ) * G ( i )
 100   continue 
c      :                                                              
c      :                                                              
c      :                                                              
c      + ================================= <150                         
c      :                                                              
  150  continue     
       iit = 0                                                           
c      :                                                              
c       + --------------<1210                                           
c      :                                                              
 1210  continue  
       do 210 i = 1 , Ip                                                   
         sx ( i ) = X ( i ) - c ( i )
 210   continue 
       isphiy = isphix 
corrected2000.10.20  1 line correction made by M.I.
c       isphix = 1 
       isphix = 0 
c      SPHI = val ,  sg = gradient computation 
       call numdif ( Model , sx , Ip ,  El , lel , sg , Vd , 1 , Step )
       SPHI = El (1)
c      :                                                              
c      ................................                                
         if( lel .le. 0)   then 
            iit = iit + 1          
               if( iit .gt. 10) then                                   
c                  ********  *                                              
                  Lcode =  72 
                  if( lpswmpi .ge. 2)
     *               write(6,*) 'B2:Initial search failed.'             
                  goto 1000 
c                 ------------------------- >1000                      
               end if                                                 
            do 304 i = 1 , Ip                                             
               c ( i ) = cst05 * c ( i )        
               do 303 j = 1 , Ip                                          
            Vd ( i , j ) = cst05 * Vd ( i ,  j )
 303        continue 
 304        continue 
            goto 1210                                                
c           ------------------------- >1210                            
         end if                                                       
c      ...............................
c      :                                                              
c      :                                                              
c      sr = v * sg                                                         
       do 310 i = 1 , Ip         
         sum = 0.d0                                
         do 311 j = 1 , Ip                                                
            sum = sum + Vd ( i , j ) * sg ( j )
 311     continue 
         sr ( i ) = sum 
 310   continue 
c      :                                                              
c      :                                                              
c      sro = ( sg )' * ( sr )                                                         '
       call innerp ( sg , sr , sro , Ip )
       arod = sro                                                        
       if( arod .lt. 0.d0) arod =  - arod                                   
       call innerp ( G , sr , gsr , Ip )   
c      :                                                              
c      :                                                              
c      maximization !                                                  
       if( PHI.lt. SPHI) then                                          
         do 560  i = 1 , Ip                                               
            X ( i ) = sx ( i )                                                
            G ( i ) = sg ( i )                                                
  560    continue                                                     
         val =  SPHI                                                    
       end if                                                          
c      :                                                              
c      :                                                              
c      convergence check 
c      ................................                             
       if( arod.lt.rhomin ) then                                         
c         **********                                                    
         Lcode  =  0                                                   
  608    format(1x  , 'B2:Bill ended with abs(RHO) =',f8.5,' < ',f8.5,
     *   ' = rhomin: code =',I3)                   
         if( lpswmpi .ge. 2) then                                            
            if( lpswmpi .eq. 3) write(6,609) NCOUNT , PHI , 
     *      SPHI - PHI , sro 
  609       format(1x ,'B3:',i5,f16.2,3x,f12.4,f12.4)                    
            write(6,608) arod , rhomin , Lcode                     
         end if                                                          
         goto 1000                                                   
c         =============================== >1000                         
       end if                                                          
c      ................................                             
c      :                                                              
c      iteration count check 
c      ................................                             
       if( limitx .gt. 0 .and. NCOUNT .gt. limitx ) then    
c         **********                                                    
         Lcode  =  50 
         if( lpswmpi .ge. 2) then                                            
            if( lpswmpi .eq. 3) write(6,609) NCOUNT , PHI , 
     *      SPHI - PHI ,
     *       sro         
            write(6,'('' B3:NCOUNT reached given limit'',I7)')
     *      limitx                     
         end if                                                          
         goto 1000                                                   
c         =============================== >1000                         
       end if                                                          
c      ................................                             
c      :                                                              
c      :                                                              
       dgam =  - gsr / sro                                                   
       dgam1 = dgam + cst1                                                 
       dgam1 = dabs ( dgam1) + 0.1d - 70                                       
       ram = dabs ( dgam ) / dgam1                                            
       if( ram.le.consta )   then                                        
         ram = consta                                                   
corrected2000.10.20  1 line correction made by M.I.
c         isphix  =  0 
         if( isphiy .ne. -1) isphix  =  1 
       end if                                                          
       if( ram.ge.constb )   then                                        
         ram = constb                                                   
corrected2000.10.20  1 line correction made by M.I.
c         isphix  =  0 
         if( isphiy .ne. 1) isphix  =  -1 
       end if                                                          
       ram1 = ram - cst1 
       ramlog  =  dlog ( ram )
corrected2000.10.20  1 line correction made by M.I.
c       ISPHI  =   ISPHI + isphiy 
       if( isphiy .eq. 0 ) ISPHI = ISPHI + 1 
       if( PHI .lt.  SPHI)  ISPHI = 0                                          
       if( lpswmpi .eq. 3) then                                            
         write(6,66) NCOUNT ,  PHI ,   SPHI - PHI , sro ,
     *   ram1 , ISPHI        
   66    format(1x ,'B3:',i5,f16.2,3x,f12.4,f12.4,f8.2,i6)                    
       end if                                                          
c      ................................                             
c      :                                                              
c      :                                                              
c      ................................                             
       if( dabs ( ramlog ) .lt. ramlim ) then                            
c         **********                                                 
         Lcode  =  70                                                
         if( lpswmpi .ge. 2) 
     *      write(6,600) dabs ( ramlog ) ,  ramlim , Lcode                 
  600       format(1x ,'B2:Bill ended with abs(log LAMBDA) = ', f6.2 ,         
     *      ' <',f6.2,'  =  ramlim: code  = ',I3)                                  
         goto 1000                                                
c        ------------------------- >1000                            
       end if                                                       
c      ................................                             
c      :                                                              
c      :                                                              
c      ................................                             
       if( ISPHI.ge.isplim ) then                                    
c         **********                                                 
         Lcode  =  71                                                
  603    format(1x ,'B2:Bill ended with  ISPHI  = ', i5,
     *              '  =  isplim: code  = ',I3) 
         if( lpswmpi .gt. 1) write(6,603)  ISPHI , Lcode                       
         goto 1000                                                
c        ------------------------- >1000                            
       end if                                                       
c      ................................                             
c      :                                                              
c      :                                                              
       ramsro = ram1 / sro                                                 
       do 481 i = 1 , Ip                                                   
         ramt = ramsro * sr ( i )                                            
         do 480 j = 1 , Ip                                                
            Vd ( i , j ) = Vd ( i , j ) + ramt * sr ( j )
 480      continue 
 481   continue 
c      :                                                              
c      :                                                              
c      maximization !                                                  
       if( SPHI .gt.  PHI) then                                          
c        : success 
         PHI =  SPHI                                                   
         do 545 i = 1 , Ip                                                
            c ( i ) = ram * sr ( i )
 545     continue 
       else                                                            
c        ................................                             
c         SPHI.le. PHI: test of correction                            
         consdr = dgam * ram1                                             
         do 550 i = 1 , Ip                                                
            c ( i ) = c ( i ) - consdr * sr ( i )
 550     continue 
c        ................................                             
       end if                                                          
c      : 
c      :                                                              
       itn = itn + 1                                                       
       goto 150                                                       
c      ================================= >150                          
c                                                                     
c      end of maximization                                             
c      + ================================== <1000                     
 1000  continue                                                        
       goto 9100 
      end                                                             

checkpoint:     lano =    77/129/sp2.@990422.@152623 ........
contents    11.3  numdif              
c reusable
      subroutine numdif ( Model , Est , Me , El , Lel , G , H , Icnt ,
     * Step )
       implicit real * 8 ( a-h , o-z )                                  
c 798 "gauss.F" 

c 1 "./dall.env" 1
       parameter (mpiprocs = 1)
       dimension mPIL ( MPIPROCS ) , mPIB ( MPIPROCS )
       common  /commpi/ iNFO , mYID , nPROCS , mPI , mPIL , mPIB 

c 800 "gauss.F" 2
       common  /cdall/ NCOUNT , limitx , lpswmpi 
       parameter ( LOCWORK = 1000)
c      !!   NOTE                                               !!
c      !!       LOCWORK should be greater than or equal me.    !!
c      !!                                                      !!
       dimension Els ( LOCWORK * 2 + 1), ivals ( LOCWORK * 2 + 1)
       dimension El (1) , G ( Me ) , H ( Me , Me ) , Est ( Me ) ,
     * Step ( Me ) 
       external Model 
       character*1  io 
c 812 "gauss.F" 

c 817 "gauss.F" 

       data inisub /0/
c      ........................................................
c      history 
c      version       date         location 
c      F_MPI_1       1996.11      ISMLIB   
c         several minor changes. The most crucial one is handling 
c         of Model output lel. Now ,  it should be:
c           Lel > 0 if Model is successfully evaluated , 
c               = 0 if Model can not be evalluated.          
c      version - 0     1998.12 
c      numdif 
c      Copyright_OML 1999 M. Ishiguro & H. Akaike 
c       The source code of this subroutine, as a part of the ARdock package,
c       can be obtained from ISMLIB(ftp://ftp.ism.ac.jp/pub/ISMLIB/)
c       of the Institute of Statistical Mathematics without any charge. 
c       On the conditions that terms of the OPEN MARKET LICENCE for software
c       (ftp://ftp.ism.ac.jp/pub/ISMLIB/OML/OML-SW-E-1996) are observed and 
c       that the copyright holder nor the Institute of Statistical Mathematics 
c       take no responsibility on any result from the use, this subroutine 
c       can be used or modified freely. On the condition that this note is 
c       attached as it is, this subroutine can be redistributed.
c      function       - numerical differentiation.                       
       io = 'I'
 9100  continue 
       if( io .eq. 'O') then
          El (1) = Elx 
       end if
c 861 "gauss.F" 

       if( io .ne. 'O') then
          call areachk (
     i    'numdif' , 'LOCWORK' , LOCWORK , Me , 1 ,
     o    ierr ) 
          goto 9200
       end if 
c      ------ 
       return 
c      ====== 
 9200  continue 
       io = 'O'
c      :                                                              
       NCOUNT  =  NCOUNT + 1                       
       ista = 1 
       iend = Me  *  2 + 1 
c 885 "gauss.F" 

       do 1496 jx = ista , iend 
         j  =  jx 
         if( jx .gt. 1) then 
           j  =  jx / 2 
           jp  =  jx - j * 2 
           epsxsc = Step ( j )                                        
           eps2sc = epsxsc ** 2                                             
           estj = Est ( j )                                                  
           if( jp .eq. 0) then 
              Est ( j ) = estj - epsxsc 
c 904 "gauss.F" 

              call Model ( Est , Me , El , lelm )

              fmd = El (1)
              Els ( jx )  =  fmd 
              ivals ( jx )  =  lelm 
           else                                    
              Est ( j ) = estj + epsxsc 
c 920 "gauss.F" 

              call Model ( Est , Me , El , lelp )

              fpd = El (1)      
              Els ( jx )  =  fpd 
              ivals ( jx )  =  lelp 
           end if 
           Est ( j )  =  estj 
         else 
c 937 "gauss.F" 

           call Model ( Est , Me , El , Lel )      

           Elx = El (1)
           Els (1)  =  Elx 
           ivals (1)  =  Lel 
         end if 
 1496  continue    
c 957 "gauss.F" 

       Elx  =  Els (1)
       Lel  =  ivals (1)
       if( Lel .le. 0) goto 9100 
c      ----------------------- 
c 965 "gauss.F" 

      if( Icnt .eq. 0) goto 9100                                          
c     ------------------------- >return                              
c      :                                                              
       do 1 j = 1 , Me                                                    
         epsxsc = Step ( j )                                        
         eps2sc = epsxsc  ** 2                                           
         fmd  =  Els ( j  * 2)
         lelm  =  ivals ( j  * 2)
         fpd  =  Els ( j  * 2 + 1)
         lelp  =  ivals ( j  * 2 + 1)
         if( lelm .le. 0) then                                          
            if( lelp .le. 0) then                                       
               fmd  =  Elx                                                
               fpd  =  Elx                                                
            else                                                      
               if( fpd .gt. Elx ) then                                    
                  fmd  =  2.d0 *  Elx - fpd                                
               else                                                   
                  fmd  =  Elx                                             
                  fpd  =  Elx                                             
               end if                                                 
            end if                                                    
         else                                                         
            if( lelp .le. 0) then                                       
               if( fmd .gt. Elx ) then                                    
                  fpd  =  2.d0 *  Elx - fmd                                
               else                                                   
                  fmd  =  Elx                                             
                  fpd  =  Elx                                             
               end if                                                 
            end if                                                    
         end if                                                       
c        :                                                            
         G ( j ) = ( fpd - fmd ) /  epsxsc  * 0.5d0 
c        :                                                            
         if( Icnt .ge. 2) then                                         
            do 2 i = 1 , Me                                               
            H ( i , j ) = 0.0d0 
 2          continue 

            H ( j , j ) = ( fpd + fmd - Elx  * 2.d0) /  eps2sc 
         end if                                                       
c        :                                                            
    1  continue                                                        
       Lel  =  1 
       goto 9100 
      end 

checkpoint:    lano =    78/129/sp2.@990422.@152623 ........
contents    11.4  innerp              
c reusable
      subroutine innerp ( Dd1 , Dd2 , Dinp12 , Id )                            
       implicit real*8 ( a-h , o-z )                                     
       dimension Dd1 (1) , Dd2 (1)                                         
c      ........................................................
c      history 
c      version       date         location 
c      F_MPI_1       1996.11      ISMLIB   
c      version - 0     1998.12 
c      innerp 
c      Computation of the inner product.
       sum = 0.0d - 00                                                     
       do 100 i = 1 , Id                                                   
         sum = sum + Dd1 ( i ) * Dd2 ( i )
 100   continue 
       Dinp12 = sum                                                      
       return                                                          
      end                                                             

checkpoint:   lano =    79/129/sp2.@990422.@152623 ........
contents    11.5  lftint              
c reusable
      function lftint ( X )                                              
       implicit real * 8 ( a-h , o-z )                                    
c      ........................................................
c      history 
c      version       date         location 
c      F_MPI_1       1996.11      ISMLIB   
c      version - 0     1998.12 
c      lftint 
c      Find the largest integer less than or equal to X.
       if( X .lt. 0.d0) then                                      
          tem = X                                                           
          ix =  - X                                                           
          ix = ix + 1                                                         
          tem = tem + ix                                                    
          lftint  =  tem                                                    
          lftint  =  lftint - ix                                            
       else 
          lftint  =  X 
       end if                                                     
       return                                                          
      end                                                             

checkpoint:  lano =    80/129/sp2.@990422.@152623 ........
contents    11.6  eval                
c reusable
      subroutine eval (
     i Model , el , Xi , Xe , M , Ndata ,  
     o Y, Rlim , 
     w D , X , Q )
       implicit real * 8 ( a - h,o - z )
c 1070 "gauss.F" 

c 1 "./dall.env" 1
       parameter (mpiprocs = 1)
       dimension mPIL ( MPIPROCS ) , mPIB ( MPIPROCS )
       common  /commpi/ iNFO , mYID , nPROCS , mPI , mPIL , mPIB 

c 1072 "gauss.F" 2
       common  /cdall/ NCOUNT , limitx , lpswmpi                  
       dimension el (1) , Y( Ndata ) , Xi ( M ) , Xe ( M ) , 
     * D ( M ) , X ( M ) ,
     * Q ( M ) 
       external Model 
       character*1  io 
c 1080 "gauss.F" 

c 1083 "gauss.F" 

       data inisub /0/
c      ........................................................
c      history 
c      version       date         location 
c      F_MPI_1       1996.11      ISMLIB   
c         several minor changes. The most crucial one is handling 
c         of Model output lel. Now ,  it should be:
c           Lel > 0 if Model is successfully evaluated , 
c               = 0 if Model can not be evalluated.          
c      version - 0     1998.12 
c      eval 
c      Copyright_OML 1999 M. Ishiguro & H. Akaike 
c       The source code of this subroutine, as a part of the ARdock package,
c       can be obtained from ISMLIB(ftp://ftp.ism.ac.jp/pub/ISMLIB/)
c       of the Institute of Statistical Mathematics without any charge. 
c       On the conditions that terms of the OPEN MARKET LICENCE for software
c       (ftp://ftp.ism.ac.jp/pub/ISMLIB/OML/OML-SW-E-1996) are observed and 
c       that the copyright holder nor the Institute of Statistical Mathematics 
c       take no responsibility on any result from the use, this subroutine 
c       can be used or modified freely. On the condition that this note is 
c       attached as it is, this subroutine can be redistributed.
       io = 'I'
 9100  continue 
c 1122 "gauss.F" 

       if( io .ne. 'O') then
          goto 9200
       end if 
c      ------ 
       return 
c      ====== 
 9200  continue 
       io = 'O'
       do 1 i = 1 , M 
         D ( i ) = ( Xe ( i ) - Xi ( i )) / ( Ndata - 1)
    1  continue 
       ista = 1 
       iend = Ndata 
c 1144 "gauss.F" 

       do 2 j = ista , iend 
         do 3 i = 1 , M     
            X ( i ) = Xi ( i ) + D ( i ) * ( j - 1) 
    3    continue 
c 1157 "gauss.F" 

         call Model ( X , M , el , Lel )

         Y( j ) = el (1)                
            if( Lel .le. 0) then  
               Rlim = 1.d40 
               Y( j ) = 1.d41  
            end if 
    2  continue                                                        
c 1174 "gauss.F" 

       goto 9100 
      end                                                             

checkpoint:             lano =   109/129/sp2.@990422.@152623 ........
contents  16. areachk              subpackage                                  
contents    16.1  areachk             
c reusable
      subroutine areachk (
     i Routine , Key , Limit , Length , Icnt ,
     o Ierr )
c 1 "./dall.env" 1
       parameter (mpiprocs = 1)
       dimension mPIL ( MPIPROCS ) , mPIB ( MPIPROCS )
       common  /commpi/ iNFO , mYID , nPROCS , mPI , mPIL , mPIB 

c 1186 "gauss.F" 2
       character*1  io 
c 1189 "gauss.F" 

       character*(*) Key , Routine 
       data inisub /0/
c      ........................................................
c      areachk 
c      Copyright_OML 1999 M. Ishiguro & H. Kato 
c       The source code of this subroutine, as a part of the ARdock package,
c       can be obtained from ISMLIB(ftp://ftp.ism.ac.jp/pub/ISMLIB/)
c       of the Institute of Statistical Mathematics without any charge. 
c       On the conditions that terms of the OPEN MARKET LICENCE for software
c       (ftp://ftp.ism.ac.jp/pub/ISMLIB/OML/OML-SW-E-1996) are observed and 
c       that the copyright holder nor the Institute of Statistical Mathematics 
c       take no responsibility on any result from the use, this subroutine 
c       can be used or modified freely. On the condition that this note is 
c       attached as it is, this subroutine can be redistributed.
       io = 'I'
 9100  continue 
c 1220 "gauss.F" 

       if( io .ne. 'O') then
          goto 9200
       end if 
c      ------ 
       return 
c      ====== 
 9199  continue 
       write(6,
     * '(1x,a,'':'',a,''( = '',i10,'') is too small, in node '',i2)')
     * Routine , Key , Limit , myid 
       write(6,'(1x,'' It should be at least '',                        '
     * i5,'' in node '',i2)') Length , myid                               '
 9198  continue
       Ierr = 1 
       call mpistop ( Icnt )
       goto 9100 
c      ========= 
 9200  continue 
       io = 'O'
       Ierr = 0 
       if( Key .eq. '{' .and. limflag .eq. 1) then
          limflag = 0
          goto 9198 
       end if
       if( Length .gt. Limit ) goto 9199 
       goto 9100 
      end 

checkpoint:                   lano =    63/129/sp2.@990422.@152623 ........
contents  9. lgraph               subpackage
contents    9.1   lgraph              
c reusable
      subroutine lgraph (
     i X , Ixn , Xmis , Cxlab , Xnorm , Xmin0 , Xmax0 , 
     i T0 , Tunit , Ctlab , Ixnlim , Iskip0 )
       implicit real * 8  ( a - h,o - z )
c 1 "./dall.env" 1
       parameter (mpiprocs = 1)
       dimension mPIL ( MPIPROCS ) , mPIB ( MPIPROCS )
       common  /commpi/ iNFO , mYID , nPROCS , mPI , mPIL , mPIB 

c 1258 "gauss.F" 2
       character*(*) Cxlab , Ctlab                                    
       dimension X ( Ixn ) ,  axis (11)    
       character*4  l (101) , lform (7) , l0 (101) 
       character*4  lformb (35) , l2x , lb , lx , li , la   
       character*1  io 
c 1265 "gauss.F" 

       data lformb  / 9*' ','10.2','11.2','12.2','13.2','14.2','15.2', 
     * '16.2','17.2','18.2','19.2','20.2','21.2','22.2','23.2','24.2',    
     * '25.2','26.2','27.2','28.2','29.2','30.2','31.2','32.2','33.2', 
     * '34.2','35.2' /    
       data lpsize /61/, lform /'(1H ',',15X',',F10','.2  ',',10F',
     * '10.2',')   '/   
       data l2x /',1X '/ 
       data lb /'    '/,  lx /'X   '/,  li /'!   '/
       data la /'*   '/  
       data inisub /0/
c      ........................................................
c      lgraph 
c      Copyright_OML 1999 M. Ishiguro & H. Akaike 
c       The source code of this subroutine, as a part of the ARdock package,
c       can be obtained from ISMLIB(ftp://ftp.ism.ac.jp/pub/ISMLIB/)
c       of the Institute of Statistical Mathematics without any charge. 
c       On the conditions that terms of the OPEN MARKET LICENCE for software
c       (ftp://ftp.ism.ac.jp/pub/ISMLIB/OML/OML-SW-E-1996) are observed and 
c       that the copyright holder nor the Institute of Statistical Mathematics 
c       take no responsibility on any result from the use, this subroutine 
c       can be used or modified freely. On the condition that this note is 
c       attached as it is, this subroutine can be redistributed.
c      this subroutine prints out the graph of time series x. 
c      data with values greater than or equal to Xmis 
c      are ignored.    
c      history:  Lower bound for the scaling was introduced. 1991.7 
c      completely refreshed 1998.7 
       io = 'I'
 9100  continue 
c 1315 "gauss.F" 

       if( io .ne. 'O') then
          goto 9200
       end if 
c      ------ 
       return 
c      ====== 
 9200  continue 
       io = 'O'
       n  =  Ixn 
       if( Iskip0 .eq. 0) then 
         iskip  =  ( Ixn - 1) / Ixnlim + 1 
       else 
         if( n .gt. Ixnlim ) n  =  Ixnlim 
         iskip = 1 
       end if                                                                
       lform (2) = l2x                                                    
c      :
       xmax  =  Xmax0 
       xmin  =  Xmin0 
       if( xmax .le. xmin ) then 
          xmax  =   - 1.d50 
          xmin  =  1.d50 
          do 10  i = 1 , n 
            if( Xmis .le. 0.d0 .or. X ( i ) .le. Xmis ) then 
               xtem  =  X ( i ) / Xnorm 
               if( xtem .gt. xmax )   xmax  =  xtem 
               if( xtem .lt. xmin )   xmin  =  xtem 
            end if 
   10    continue 
       end if 
c      :                                                              
       xdif  =  xmax - xmin                                              
       if( xdif .le. 1.d0) xdif = 1.d0                                    
c      :                                                              
       power  =  dlog10 ( xdif )                                            
       ix = lftint ( power )                                                
       power  =  10.d0 ** ix                                               
       xdifn  =  xdif  / power                                             
c      :                                                              
       u  =  0.25d0                                                      
       if( xdifn .ge. 1.25d0) u = 0.5d0                                   
       if( xdifn .ge. 2.5d0) u = 1.d0                                     
       if( xdifn .ge. 5.0d0) u = 2.d0                                     
c      :                                                              
       unit  =  u  *  power                                                
       num  =  xdif / unit 
c      1998.7.10                                                 
       itest = 1 
       if( itest .eq. 0) then 
          num = num + 2 
       else 
          num2  =  num / 2 + 1 
          num = num2 * 2 
       end if                                                      
       lp  =  lpsize / num                                                 
       mesh  =  lp * num                                                   
       lpmax = mesh + 1                                                  
       if( xmin .ge. 0.d0) ixmin  =  xmin / unit                            
       if( xmin .lt. 0.d0) ixmin  =  xmin / unit - 1                        
       xmin  =  ixmin * unit                                               
       if( xmin + num * unit .lt. xmax ) num = num + 1 
       xmax  =  xmin + num * unit                                          
c      :                                                              
       xd  =  ( xmax - xmin ) / mesh                                           
       xd2  =  xd * 0.5                                                    
       xd10  =  xd * lp                                                    
       xmin2  =  xmin - xd2                                              
       nump1 = num + 1                                                     
       rel  =  xmax + xmin                                                 
       rel  =  abs ( rel )  *  0.5  / ( xmax - xmin )                             
c      :                                                              
       if( myid .eq. 0) then 
          write(6,*) Ctlab , 'vs.  ' , Cxlab 
       end if                                               
       if( rel .le. 50.0) then                                         
          xbase  =  xmin                                                 
       else                                                            
          xbase  =  0.0                                                  
          write(6 , 2600) xmin                                           
 2600     format(51x , '( + ' , e13.6 , ' )')                                
       end if                                                          
c      :                                                              
       do 40  i = 1 , nump1 
          axis ( i )  =  xbase + xd10 * ( i - 1)                                   
          if( abs ( axis ( i )) .lt. xd10 * 0.0001) axis ( i ) = 0.0 
   40  continue                                                        
c      :                                                              
       lform (6) = lformb ( lp )                                             
       write( 6 , lform )   ( axis ( i ) , i = 1 , nump1)                          
c      :                                                              
       do 50  j = 1 , lpmax                                                
          if( mod ( j , lp ) .eq. 1 ) then                                     
             l0 ( j )  =  li                                                   
          else                                                            
             l0 ( j )  =  lb                                                   
          end if                                                          
   50  continue                                                        
c      :                                                              
       mod0 = mod ( n - 1 , iskip )
       mod1 = 0
       do 100  i = 1 , n 
          if( mod ( i - 1 , iskip ) .ne. mod0 ) goto 100
c         ----------------------------------------------
          mod1 = mod1 + 1
          do 60  j = 1 , lpmax 
             l ( j )  =  l0 ( j ) 
 60       continue 
          xi  =  X ( i ) / Xnorm  
          if( i - iskip .ge. 1) xim1  =  X ( i - iskip ) / Xnorm  
          if( i + iskip .le. n ) xip1  =  X ( i + iskip ) / Xnorm 
          item  =  ( xi - xmin2) / xd + 1                                     
          item0  =  item                                                 
          item1  =  item                                                 
          if( mod1 .gt. 1) item0  =  ( xim1 - xmin2) / xd + 1                 
          if( i .lt. n ) item1  =  ( xip1 - xmin2) / xd + 1                   
          if( item .ge. 1 .and. item .le. lpmax ) then                  
            if( item0 .lt. item )   item0  =  item - 
     *      ( item - item0 - 1) / 2   
            if( item0 .gt. item )   item0  =  item + 
     *      ( item0 - item - 1) / 2   
            if( item1 .lt. item )   item1  =  item - 
     *      ( item - item1 - 1) / 2   
            if( item1 .gt. item )   item1  =  item + 
     *      ( item1 - item - 1) / 2   
            if( item1 .gt. lpmax ) item1  =  item                         
            if( item1 .lt. 1) item1  =  item                             
            if( item0 .gt. lpmax ) item0  =  item                         
            if( item0 .lt. 1) item0  =  item                             
            jtem0  =  item0                                             
            if( jtem0 .gt. item ) jtem0 = item                            
            if( jtem0 .gt. item1) jtem0 = item1                          
            jtem1  =  item0                                             
            if( jtem1 .lt. item ) jtem1 = item                            
            if( jtem1 .lt. item1) jtem1  =  item1                        
            do 80 j = jtem0 , jtem1                                       
               l ( j )  =  lx 
 80         continue 
            l ( item )  =  la                                              
          end if                                                       
          write(6 , 1602) ( i - 1) * Tunit + T0 ,
     *    ( l ( j ) , j = 1 , lpmax ) 
 1602     format(2x  , F7.2 , 1x , 101a1)                                   
  100  continue                                                        
       goto 9100                                                          
      end 

checkpoint:                  lano =   104/129/sp2.@990422.@152623 ........
contents    14.7  mpistop             
c reusable
      subroutine mpistop ( Ie )
c 1468 "gauss.F" 

c      ........................................................
c      mpistop 
c      Stops (parallel) computation.
       if( Ie .eq. 0) return 
       close (91)
       close (99)
       close (IOUNIT)
c 1478 "gauss.F" 

       stop 
      end 

c 1758 "gauss.F" 

